
sub labelaxes {
    my ($frame, $row, $units) = @_ ;
    my $emphaticColor = "#ffff00" ;
    my $Balloon = $frame->Balloon( -background=>$emphaticColor, -width=>60) ;   
    my $err = errno ; 

    my $col = 0 ; 
    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "axis",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> "Component label" ) ;

    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "hang",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> "degrees clockwise from north; 0=North" ) ;

    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "vang",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> "degrees from vertical upwards: 0=up 90=horizontal" ) ;

    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "sensitivity",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> $units ) ;

    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "datalogger gain",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> "counts/volt" ) ;

    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "preamp gain",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> "optional preamp gain (V/V)" ) ;

    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "preamp stage",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> "optional preamp stage" ) ;

    my $e = $frame->Label  (
		-font=>"ptkformLabel",
		-text => "lead",
		-fg=>"darkblue",
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;
	    $Balloon->attach($e, -balloonmsg=> "Datalogger lead" ) ;

}

sub addaxis {
    my ($frame, $row, $component ) = @_ ;

    my $col = 0 ;
    my $e = $frame->Entry(
		-textvariable=>\$component->axis,
		-font=>"ptkformEntry",
		-width=>'1',
		)
	->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"e" );
    $e->bind("<Key>", sub {$component->by_hand=1} ) ; 
    my $axis_widget = $e ; 

    $e = $frame->Entry(
		-textvariable=>\$component->hang,
		-font=>"ptkformEntry",
		-width=>'8',
		)
	->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw");
    $e->bind("<Key>", sub {$component->by_hand=1} ) ; 
    $e = $frame->Entry(
		-textvariable=>\$component->vang,
		-font=>"ptkformEntry",
		-width=>8,
		)
	->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw");
    $e->bind("<Key>", sub {$component->by_hand=1} ) ; 

    $e = $frame->Entry(
		-textvariable=>\$component->sensor_gain,
		-font=>"ptkformEntry",
		-width=>'12',
		)
	->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw");
    $e->bind("<Key>", sub {$component->by_hand=1} ) ; 
    $component->w_sensor_gain = $e ;

    $e = $frame->Entry(
		-textvariable=>\$component->datalogger_gain,
		-font=>"ptkformEntry",
		-width=>'12',
		)
	->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw");
    $e->bind("<Key>", sub {$component->by_hand=1} ) ; 
    $component->w_datalogger_gain = $e ;

    $e = $frame->Entry(
		-textvariable=>\$component->preamp_gain,
		-font=>"ptkformEntry",
		-width=>12,
		)
	->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw");
    $e->bind("<Key>", sub {$component->by_hand=1} ) ; 

    $ref = $Configuration->preamps ; 
    $e = $frame->BrowseEntry  (
		-font=>"ptkformEntry",
		-choices=>\@$ref, 
		-width=>10,
		-variable=>\$component->preamp_stage,
		)
	    ->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw" ) ;

    $e = $frame->Entry(
		-textvariable=>\$component->lead,
		-font=>"ptkformEntry",
		-width=>3,
		)
	->grid(-row=>$row, -column=>$col++, -ipady=>0, -pady=>0, -sticky=>"nw");
    $e->bind("<Key>", sub {$component->by_hand=1} ) ; 

    return $axis_widget ;
}

1;
